%INPUT: cell of simple unweighted graphs with n vertices
%OUTPUT: cell of graphs built by H1-step up to isomorphism with n+1
%vertices, connections used to construct the new graph

function[H1,STEP]=H1_3D(G)
H={};
H1={};
STEP=[];
S=1;

k=size(G,2);


for h=1:k
 A=G{h};
 n=numnodes(A);
 
 if mod(h,50)==0
     display(['First ', num2str(h),' H1 Graphs Complete. Number of new graphs=', num2str(n1)])
 end
 
 for i=1:n-2
     for j=i+1:n-1
         for s=j+1:n
           B=addedge(A,[i j s],[n+1 n+1 n+1]);
                
           n1=size(H,2);
           flag=0;
           m=1;
           
           while m<n1+0.1 && flag==0
               
               if isisomorphic(B,H{m})
                flag=1;
               end
               m=m+1; 
           end
             
           
           if flag==0
           
             H1=cell(1,n1+1);
             H1(1:n1)=H;
             
             
             H1{n1+1}=B;
             H=H1;
             Step(S).add=[i j s];
             S=S+1;
             
           end
             
             
          
         end
         
     end
 end
    
    
end


end