%INPUT: cell of simple unweighted graphs
%OUTPUT: cell of non-isomorphic graphs built  by H3-step


function[H3]=H3_3D_x(G)
H={};
H3={};
k=size(G,2);

for h=1:k
if mod(h,50)==0
     display(['First ', num2str(h),' H3 Graphs Complete'])
     
 end
A=G{h}; 
V=numnodes(A);
E=numedges(A);
[s1,t1]=findedge(A);



for i1=1:E-1
    B= rmedge(A,s1(i1),t1(i1)); 
   B=addedge(B,[s1(i1) t1(i1)],[V+1 V+1]);
   L1=1:V;
   L1=L1(L1~=s1(i1));
   L1=L1(L1~=t1(i1)); 

   subA = subgraph(A,L1);
   subE=numedges(subA);
   [s2,t2]=findedge(subA);
   
   for i2=1:subE
      C= rmedge(B,L1(s2(i2)),L1(t2(i2))); 
      C=addedge(C,[L1(s2(i2)) L1(t2(i2))],[V+1 V+1]);
      
      L2=L1;
      L2=L2(L2~=L1(s2(i2)));
      L2=L2(L2~=L1(t2(i2)));
      
      
      s=size(L2,2);
      
      for j=1:s
          D=addedge(C,L2(j),V+1);
         n1=size(H,2);
           flag=0;
           m=1;
           
           while m<n1+0.1 && flag==0
               
               if isisomorphic(D,H{m})
                flag=1;
               end
               m=m+1; 
           end
             
           
           if flag==0
           
             H3=cell(1,n1+1);
             H3(1:n1)=H;
             
             
             H3{n1+1}=D;
             H=H3;
           end    
          
          
      end
       
       
       
   end
   
   

end






end

end