%INPUT cell of graphs characterized for s step
%OUTPUT cell of graphs characterized for s step
function[H1,H2,H3]=H_characterization_3D(G)


[H1]=H1_3D(G);
n1=size(H1,2); %Graphs built by H1

display(['H1 Complete   ----   ', num2str(n1),' graphs'])
H2={};
H3={};
k=size(G,2);

if n1>0

    
    
    
%H2 characterization
H={};
for h=1:k

A=G{h}; 
V=numnodes(A);
E=numedges(A);
[s,t]=findedge(A);

for i=1:E
   B= rmedge(A,s(i),t(i)); 
   B=addedge(B,[s(i) t(i)],[V+1 V+1]);
   L=1:V;
   L=L(L~=s(i));
   L=L(L~=t(i));
   
   for j1=1:V-3
       for j2=j1+1:V-2
            
            C=addedge(B,[L(j1) L(j2)],[V+1 V+1]);
           
           n2=size(H,2);
           flag=0;
           m=1;
           %Checking H1 isomorphisms
    while m<n1+0.1 && flag==0
       
            if isisomorphic(H1{m},C)
                flag=1;
            end
        
        m=m+1;
    end
           
           
           m=1;
           
           while m<n2+0.1 && flag==0
               
               if isisomorphic(C,H{m}) %Checking H2 isomorphisms
                flag=1;
               end
               m=m+1; 
           end
             
           
           if flag==0
           
             H2=cell(1,n2+1);
             H2(1:n2)=H;
             
             
             H2{n2+1}=C;
             H=H2;
           end     
           
           
       end 
   end
   
   
   
   
end


end

clear H m flag A B C s t L
n2=size(H2,2);
display(['H2 Complete   ----   ', num2str(n2),' graphs'])
if n2>0
%H3 characterization
if V>12

H={};    


for h=1:k

A=G{h}; 
V=numnodes(A);
E=numedges(A);
[s1,t1]=findedge(A);

for i1=1:E-1
    B= rmedge(A,s1(i1),t1(i1)); 
   B=addedge(B,[s1(i1) t1(i1)],[V+1 V+1]);
   L1=1:V;
   L1=L1(L1~=s1(i1));
   L1=L1(L1~=t1(i1)); 

   subA = subgraph(A,L1);
   subE=numedges(subA);
   [s2,t2]=findedge(subA);
   
   for i2=1:subE
      C= rmedge(B,L1(s2(i2)),L1(t2(i2))); 
      C=addedge(C,[L1(s2(i2)) L1(t2(i2))],[V+1 V+1]);
      
      L2=L1;
      L2=L2(L2~=L1(s2(i2)));
      L2=L2(L2~=L1(t2(i2)));
      
      
      s=size(L2,2);
      
      for j=1:s
          D=addedge(C,L2(j),V+1);
         n3=size(H,2);
           flag=0;
          
          
           %Checking H1 isomorphisms
          m=1;
           
           while m<n1+0.1 && flag==0
               
               if isisomorphic(D,H1{m})
                flag=1;
               end
               m=m+1; 
           end
            
           %Checking H1 isomorphisms
          m=1; %re initialize counter
           
           while m<n2+0.1 && flag==0
               
               if isisomorphic(D,H2{m})
                flag=1;
               end
               m=m+1; 
           end
           
           %Checking H1 isomorphisms
          m=1; %re initialize counter
           
           while m<n3+0.1 && flag==0
               
               if isisomorphic(D,H{m})
                flag=1;
               end
               m=m+1; 
           end
           
           
           if flag==0
           
             H3=cell(1,n3+1);
             H3(1:n3)=H;
             
             
             H3{n3+1}=D;
             H=H3;
           end    
          
          
      end
       
       
       
   end
   
   

end


end
n3=size(H3,2);
display(['H3 Complete   ----   ', num2str(n3),' graphs'])
end

end

end

end
